<?php
require_once __DIR__ . '/classes/GloboManager.php';

function validateRequest(): void {
    $required = ['id', 'lat', 'long'];
    foreach ($required as $param) {
        if (!isset($_GET[$param]) || empty($_GET[$param])) {
            throw new InvalidArgumentException("Parâmetro obrigatório ausente: $param");
        }
    }
}

try {
    validateRequest();
    
    $manager = new GloboManager();
    $videoId = $_GET['id'];
    $lat = $_GET['lat'];
    $long = $_GET['long'];
    $quality = $_GET['quality'] ?? 'HD';
    $getDrm = isset($_GET['drm']) && $_GET['drm'] === 'yes';

    if ($getDrm) {
        $streamUrl = $manager->getStreamUrl($videoId, $lat, $long, $quality);
        $key = $manager->getDrmKey($streamUrl);
        
        header('Content-Type: text/plain');
        echo $key ?? 'Chave DRM não encontrada';
    } else {
        $streamUrl = $manager->getStreamUrl($videoId, $lat, $long, $quality);
        header('Location: ' . $streamUrl);
    }
    exit;

} catch (Exception $e) {
    http_response_code(500);
    header('Content-Type: application/json');
    echo json_encode([
        'error' => true,
        'message' => $e->getMessage()
    ]);
    exit;
}